> For the complete documentation index, see [llms.txt](https://docs.hyphen.at/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.hyphen.at/android/handling-2fa-transaction-request.md).

# Handling 2FA / Transaction Request

## Request Notification Permission

You must request **Notification Permission** to receive notifications from Android 13+.

{% embed url="<https://developer.android.com/develop/ui/views/notifications/notification-permission>" %}

## Add Firebase Messaging Service

`FirebaseMessagingService` must be implemented to receive push notifications. If the service is already exist, you only need to add code related to Hyphen.

{% tabs %}
{% tab title="SampleMessagingService.kt" %}

```kotlin
import at.hyphen.android.sdk.ui.HyphenUI
import com.google.firebase.messaging.FirebaseMessagingService
import com.google.firebase.messaging.RemoteMessage

class SampleMessagingService : FirebaseMessagingService() {

    override fun onMessageReceived(message: RemoteMessage) {
        HyphenUI.onFirebaseMessageReceived(applicationContext, message)
    }
}
```

{% endtab %}

{% tab title="AndroidManifest.xml" %}

```xml
<service
    android:name=".SampleMessagingService"
    android:exported="false">
    <intent-filter>
        <action android:name="com.google.firebase.MESSAGING_EVENT" />
    </intent-filter>
</service>
```

{% endtab %}
{% endtabs %}

## Handling Hyphen Notification Click

Add the code below to the root activity to ensure proper handling when click Hyphen push notification.

{% tabs %}
{% tab title="\[YourActivityName]Activity.kt" %}

```kotlin
class MainActivity : AppCompatActivity(), HyphenAuthenticateDelegate {
    
    // ...
    
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        
        intent?.let {
            HyphenUI.handleHyphenIntent(this, it)
        }
    }
    
    // ...
    
    override fun onNewIntent(intent: Intent?) {
        super.onNewIntent(intent)

        intent?.let {
            HyphenUI.handleHyphenIntent(this, it)
        }
    }
}
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.hyphen.at/android/handling-2fa-transaction-request.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
